%{
#include "rotfl.h"
#include "y.tab.h"
%}

IDENTFIRSTCHAR	[a-zA-Z_*~=]
IDENTCHAR	[a-zA-Z0-9_*~=/-]
IDENTLASTCHAR	[a-zA-Z0-9_*~=]

%%

[ \t\r\n]+	/* Eat up whitespace */

"#"[^\n]*\n	/* Eat up comments */

{IDENTFIRSTCHAR}{IDENTCHAR}*{IDENTLASTCHAR} yylval.ident = hash (yytext); return TOK_IDENT;
{IDENTFIRSTCHAR} yylval.ident = hash (yytext); return TOK_IDENT;

"@f"		yylval.boolean_v = 0;  return TOK_BOOLEAN;
"@t"		yylval.boolean_v = 1;  return TOK_BOOLEAN;

"-"?[0-9]+      yylval.integer_v = atoi (yytext);  return TOK_INTEGER;

"@'".		yylval.character_v = yytext[2];  return TOK_CHARACTER;
"@\\n"		yylval.character_v = '\n';  return TOK_CHARACTER;
"@\\r"		yylval.character_v = '\r';  return TOK_CHARACTER;
"@\\t"		yylval.character_v = '\t';  return TOK_CHARACTER;

"@@"		return TOK_CURENV;
"@-"		return TOK_NULLENV;

"("		return TOK_LPAREN;

")"		return TOK_RPAREN;

"{"		return TOK_LBRACE;

"}"		return TOK_RBRACE;

"?"		return TOK_QUESTION;
":"		return TOK_COLON;

";"		return TOK_SEMICOLON;

">"		return TOK_ARROW;

.		error ("invalid character");
