#include <stdlib.h>

#include <gc.h>

#include "rotfl.h"
#include "object.h"

enum object_type_e
obj_type (object_t obj)
{
  return obj->generic.t;
}

#define CHKTYPE(obj,tp) \
	if ( obj->generic.t != tp ) error ("Type " #tp " was expected")

#include "o_bodies.c"

object_t
no_object (void)
{
  return NULL;
}

#if 1

static object_t
new_object (enum object_type_e t)
{
  object_t obj;

  obj = GC_malloc (sizeof(*obj));
  obj->generic.t = t;
  return obj;
}

#else

#include <stdio.h>

static object_t
_new_object (const char *ts, enum object_type_e t)
{
  object_t obj;

  fprintf (stderr, "Allocating object of type %s\n", ts);
  obj = GC_malloc (sizeof(*obj));
  obj->generic.t = t;
  return obj;
}

#define new_object(t) \
	_new_object (#t, t)

#endif

#include "new_bodies.c"

#include "mod_bodies.c"
