#include <stdio.h>

#include "rotfl.h"
#include "eval.h"

static int pf_argc[PF_COUNT] = {
  1, /* PF_ID */
  1, /* PF_EXIT */
  1, /* PF_REF */
  1, /* PF_DEREF */
  2, /* PF_SET */
  2, /* PF_EXCH */
  1, /* PF_PRINT */
  1, /* PF_WRITE */
  2, /* PF_EVAL */
  2, /* PF_APPLY */
  1, /* PF_CALL_CC */
  1, /* PF_QUOTE */
  2, /* PF_MAKE_TASK */
  2, /* PF_STEP_TASK */
};

static void
do_primfunc (enum pfv_e num)
{
  switch ( num )
    {
    case PF_ID:
      reg_val = reg_erand;
      break;
    case PF_EXIT:
      reg_val = reg_erand;
      reg_cont = new_cont_final ();
      break;
    case PF_REF:
      reg_val = new_ref (reg_erand);
      break;
    case PF_DEREF:
      reg_val = o_ref_deref (reg_erand);
      break;
    case PF_SET:
      mod_ref (o_primfunc1_par0 (reg_erator), reg_erand);
      reg_val = new_unit ();
      break;
    case PF_EXCH:
      reg_val = o_ref_deref (o_primfunc1_par0 (reg_erator));
      mod_ref (o_primfunc1_par0 (reg_erator), o_ref_deref (reg_erand));
      mod_ref (reg_erand, reg_val);
      reg_val = new_unit ();
      break;
    case PF_PRINT:
      switch ( obj_type (reg_erand) )
	{
	case O_CHARACTER:
	  printf ("%c", o_character_val (reg_erand));
	  break;
	default:
	  error ("Uncaught case in PF_PRINT");
	  break;
	}
      reg_val = new_unit ();
      break;
    case PF_WRITE:
      switch ( obj_type (reg_erand) )
	{
	case O_UNIT:
	  printf ("()\n");
	  break;
	case O_BOOLEAN:
	  printf (o_boolean_val (reg_erand) ? "@t\n" : "@f\n");
	  break;
	case O_INTEGER:
	  printf ("%d\n", o_integer_val (reg_erand));
	  break;
	case O_CHARACTER:
	  switch ( o_character_val (reg_erand) )
	    {
	    case '\n': printf ("@\\n\n"); break;
	    case '\r': printf ("@\\r\n"); break;
	    case '\t': printf ("@\\t\n"); break;
	    default: printf ("@'%c\n", o_character_val (reg_erand)); break;
	    }
	  break;
	case O_REF:
	  printf ("@<ref>\n");
	  break;
	case O_USERFUNC:
	case O_PRIMFUNC:
	case O_PRIMFUNC1:
	case O_PRIMFUNC2:
	  printf ("@<function>\n");
	  break;
	case O_CONT_FINAL:
	case O_CONT_EVAL:
	case O_CONT_APP1:
	case O_CONT_APP:
	case O_CONT_TEST:
	case O_CONT_REFL:
	  printf ("@<continuation>\n");
	  break;
	case O_TASK:
	  printf ("@<task>\n");
	  break;
	case O_ENV_EMPTY:
	case O_ENV_BINDING:
	  printf ("@<environment>\n");
	  break;
	default:
	  printf ("@<unprintable>\n");
	  break;
	}
      reg_val = new_unit ();
      break;
    case PF_EVAL:
      reg_cont = new_cont_eval (o_primfunc1_par0 (reg_erator),
				reg_erand, reg_cont);
      break;
    case PF_APPLY:
      reg_val = reg_erand;
      reg_cont = new_cont_app (o_primfunc1_par0 (reg_erator), reg_cont);
      break;
    case PF_CALL_CC:
      reg_val = reg_cont;
      reg_cont = new_cont_app (reg_erand, reg_cont);
      break;
    case PF_QUOTE:
      reg_val = new_quote (reg_erand);
      break;
    case PF_MAKE_TASK:
      reg_val = new_task (o_primfunc1_par0 (reg_erator), reg_erand);
      break;
    case PF_STEP_TASK:
      reg_val = reg_erand;
      reg_cont = new_cont_refl (o_integer_val (o_primfunc1_par0 (reg_erator)),
				reg_cont);
      break;
    default:
      error ("Uncaught case in do_primfunc()");
      break;
    }
}

void
apply_primfunc (void)
{
  if ( pf_argc[o_primfunc_num (reg_erator)] > 1 )
    {
      reg_val = new_primfunc1 (o_primfunc_num (reg_erator),
			       reg_erand);
      return;
    }
  do_primfunc (o_primfunc_num (reg_erator));
}

void
apply_primfunc1 (void)
{
  if ( pf_argc[o_primfunc1_num (reg_erator)] > 2 )
    {
      reg_val = new_primfunc2 (o_primfunc1_num (reg_erator),
			       o_primfunc1_par0 (reg_erator),
			       reg_erand);
      return;
    }
  do_primfunc (o_primfunc1_num (reg_erator));
}

void
apply_primfunc2 (void)
{
  if ( pf_argc[o_primfunc2_num (reg_erator)] > 3 )
    {
      error ("Primfunc has too many arguments!");
      return;
    }
  do_primfunc (o_primfunc2_num (reg_erator));
}
